/*
Code automatically generated by asn1scc tool
*/
#include <limits.h>
#include <string.h>
#include <math.h>
#include "taste-extended.h"

#if !defined(_MSC_VER) || _MSC_VER >= 1800
void T_Double_Initialize(T_Double* pVal)
{
    *pVal = (T_Double) 0.00000000000000000000E+000;
}
#endif

 
flag T_Double_IsConstraintValid(const T_Double* pVal, int* pErrCode)
{
    
    flag ret = TRUE;
	*pErrCode=0;

	(void)pVal;

	ret = (-1.79769313486231570000E+308 <= *pVal && *pVal <= 1.79769313486231570000E+308);
	*pErrCode = ret ? 0 : ERR_T_Double;

	return ret;
}

flag T_Double_Encode(const T_Double* pVal, BitStream* pBitStrm, int* pErrCode, flag bCheckConstraints)
{
    flag ret = TRUE;
    
	ret = bCheckConstraints ? T_Double_IsConstraintValid(pVal, pErrCode) : TRUE ;
	if (ret) {
	    BitStream_EncodeReal(pBitStrm, *pVal);
    }

	return ret;
}

flag T_Double_Decode(T_Double* pVal, BitStream* pBitStrm, int* pErrCode)
{
    flag ret = TRUE;

	BitStream_DecodeReal(pBitStrm, pVal);
	*pErrCode = ret ? 0 : 268959745;

	return ret;
}
#if !defined(_MSC_VER) || _MSC_VER >= 1800
void T_Float_Initialize(T_Float* pVal)
{
    *pVal = (T_Float) 0.00000000000000000000E+000;
}
#endif

 
flag T_Float_IsConstraintValid(const T_Float* pVal, int* pErrCode)
{
    
    flag ret = TRUE;
	*pErrCode=0;

	(void)pVal;

	ret = (-3.40282346600000020000E+038 <= *pVal && *pVal <= 3.40282346600000020000E+038);
	*pErrCode = ret ? 0 : ERR_T_Float;

	return ret;
}

flag T_Float_Encode(const T_Float* pVal, BitStream* pBitStrm, int* pErrCode, flag bCheckConstraints)
{
    flag ret = TRUE;
    
	ret = bCheckConstraints ? T_Float_IsConstraintValid(pVal, pErrCode) : TRUE ;
	if (ret) {
	    BitStream_EncodeReal(pBitStrm, *pVal);
    }

	return ret;
}

flag T_Float_Decode(T_Float* pVal, BitStream* pBitStrm, int* pErrCode)
{
    flag ret = TRUE;

	BitStream_DecodeReal(pBitStrm, pVal);
	*pErrCode = ret ? 0 : 268959746;

	return ret;
}
#if !defined(_MSC_VER) || _MSC_VER >= 1800
void T_Int16_Initialize(T_Int16* pVal)
{
    *pVal = (T_Int16) -32768;
}
#endif

 
flag T_Int16_IsConstraintValid(const T_Int16* pVal, int* pErrCode)
{
    
    flag ret = TRUE;
	*pErrCode=0;

	(void)pVal;

	ret = (-32768 <= *pVal && *pVal <= 32767);
	*pErrCode = ret ? 0 : ERR_T_Int16;

	return ret;
}

flag T_Int16_Encode(const T_Int16* pVal, BitStream* pBitStrm, int* pErrCode, flag bCheckConstraints)
{
    flag ret = TRUE;
    
	ret = bCheckConstraints ? T_Int16_IsConstraintValid(pVal, pErrCode) : TRUE ;
	if (ret) {
	    BitStream_EncodeConstraintWholeNumber(pBitStrm, *pVal, -32768, 32767);
    }

	return ret;
}

flag T_Int16_Decode(T_Int16* pVal, BitStream* pBitStrm, int* pErrCode)
{
    flag ret = TRUE;

	ret = BitStream_DecodeConstraintWholeNumber(pBitStrm, pVal, -32768, 32767);
	*pErrCode = ret ? 0 : 268959747;

	return ret;
}
#if !defined(_MSC_VER) || _MSC_VER >= 1800
void T_UInt16_Initialize(T_UInt16* pVal)
{
    *pVal = (T_UInt16) 0;
}
#endif

 
flag T_UInt16_IsConstraintValid(const T_UInt16* pVal, int* pErrCode)
{
    
    flag ret = TRUE;
	*pErrCode=0;

	(void)pVal;

	ret = (*pVal <= 65535);
	*pErrCode = ret ? 0 : ERR_T_UInt16;

	return ret;
}

flag T_UInt16_Encode(const T_UInt16* pVal, BitStream* pBitStrm, int* pErrCode, flag bCheckConstraints)
{
    flag ret = TRUE;
    
	ret = bCheckConstraints ? T_UInt16_IsConstraintValid(pVal, pErrCode) : TRUE ;
	if (ret) {
	    BitStream_EncodeConstraintPosWholeNumber(pBitStrm, *pVal, 0, 65535);
    }

	return ret;
}

flag T_UInt16_Decode(T_UInt16* pVal, BitStream* pBitStrm, int* pErrCode)
{
    flag ret = TRUE;

	ret = BitStream_DecodeConstraintPosWholeNumber(pBitStrm, pVal, 0, 65535);
	*pErrCode = ret ? 0 : 268959748;

	return ret;
}
#if !defined(_MSC_VER) || _MSC_VER >= 1800
void T_UInt64_Initialize(T_UInt64* pVal)
{
    *pVal = (T_UInt64) 0;
}
#endif

 
flag T_UInt64_IsConstraintValid(const T_UInt64* pVal, int* pErrCode)
{
    
    flag ret = TRUE;
	*pErrCode=0;

	(void)pVal;

	ret = (*pVal <= 9223372036854775807LL);
	*pErrCode = ret ? 0 : ERR_T_UInt64;

	return ret;
}

flag T_UInt64_Encode(const T_UInt64* pVal, BitStream* pBitStrm, int* pErrCode, flag bCheckConstraints)
{
    flag ret = TRUE;
    
	ret = bCheckConstraints ? T_UInt64_IsConstraintValid(pVal, pErrCode) : TRUE ;
	if (ret) {
	    BitStream_EncodeConstraintPosWholeNumber(pBitStrm, *pVal, 0, 9223372036854775807LL);
    }

	return ret;
}

flag T_UInt64_Decode(T_UInt64* pVal, BitStream* pBitStrm, int* pErrCode)
{
    flag ret = TRUE;

	ret = BitStream_DecodeConstraintPosWholeNumber(pBitStrm, pVal, 0, 9223372036854775807LL);
	*pErrCode = ret ? 0 : 268959749;

	return ret;
}
#if !defined(_MSC_VER) || _MSC_VER >= 1800
void T_Int64_Initialize(T_Int64* pVal)
{
    *pVal = (T_Int64) -9223372036854775807LL;
}
#endif

 
flag T_Int64_IsConstraintValid(const T_Int64* pVal, int* pErrCode)
{
    
    flag ret = TRUE;
	*pErrCode=0;

	(void)pVal;

	ret = (-9223372036854775807LL <= *pVal && *pVal <= 9223372036854775807LL);
	*pErrCode = ret ? 0 : ERR_T_Int64;

	return ret;
}

flag T_Int64_Encode(const T_Int64* pVal, BitStream* pBitStrm, int* pErrCode, flag bCheckConstraints)
{
    flag ret = TRUE;
    
	ret = bCheckConstraints ? T_Int64_IsConstraintValid(pVal, pErrCode) : TRUE ;
	if (ret) {
	    BitStream_EncodeConstraintWholeNumber(pBitStrm, *pVal, -9223372036854775807LL, 9223372036854775807LL);
    }

	return ret;
}

flag T_Int64_Decode(T_Int64* pVal, BitStream* pBitStrm, int* pErrCode)
{
    flag ret = TRUE;

	ret = BitStream_DecodeConstraintWholeNumber(pBitStrm, pVal, -9223372036854775807LL, 9223372036854775807LL);
	*pErrCode = ret ? 0 : 268959750;

	return ret;
}
#if !defined(_MSC_VER) || _MSC_VER >= 1800
void T_String_Initialize(T_String* pVal)
{
    *pVal = (T_String) {0,
    {
    }
};
}
#endif

 
flag T_String_IsConstraintValid(const T_String* pVal, int* pErrCode)
{
    
    flag ret = TRUE;
	*pErrCode=0;

	(void)pVal;

	ret = (0 <= pVal->nCount && pVal->nCount <= (int)maxSize_T_String);
	*pErrCode = ret ? 0 : ERR_T_String;

	return ret;
}

flag T_String_Encode(const T_String* pVal, BitStream* pBitStrm, int* pErrCode, flag bCheckConstraints)
{
    flag ret = TRUE;
	int i1=0;
    
	ret = bCheckConstraints ? T_String_IsConstraintValid(pVal, pErrCode) : TRUE ;
	if (ret) {
	    BitStream_EncodeConstraintWholeNumber(pBitStrm, pVal->nCount, 0, 256);
	    	
	    for(i1=0; (i1 < (int)pVal->nCount) && ret; i1++) 
	    {
	    	BitStream_AppendByte0(pBitStrm, pVal->arr[i1]);
	    }
    }

	return ret;
}

flag T_String_Decode(T_String* pVal, BitStream* pBitStrm, int* pErrCode)
{
    flag ret = TRUE;
	asn1SccSint nCount;
	int i1=0;

	ret = BitStream_DecodeConstraintWholeNumber(pBitStrm, &nCount, 0, 256);
	*pErrCode = ret ? 0 : 268959751;
	pVal->nCount = (long)nCount;
		
	for(i1=0; (i1 < (int)pVal->nCount) && ret; i1++) 
	{
		ret = BitStream_ReadByte(pBitStrm, &pVal->arr[i1]); 
		*pErrCode = ret ? 0 : 268959752;
	}

	return ret;
}

const T_UInt32 maxSize_T_String = 256;
